class Token #Nombres de las clases deben empezar en mayusculas
  attr_reader :type, :line, :col  #Nombre de metodos
  
  def initialize(type,lineNum,colNum) #constructor(initialize(debe tener parametros diferentes no se les pone el tipo))
    @type = type # @ -> Variables de Instancia , $ -> Variables Globales
    @line = lineNum
    @col = colNum
  end
end

class LexicalToken < Token #Herencia
  attr_reader :lex
  
  def initialize(type,lex,lineNum,colNum)
    super(type,lineNum,colNum)
    
    @lex = lex
  end
end


=begin
attr_reader -> Da el metodo para leer la variable (get)
attr_writer -> (set)
attr_accessor -> reader + writer (get y set)
: -> inmutables
=end
